commit e01438dd50f231055ac835e2f7d4bf94ab91f76d
Author: freddy77 <freddy77>
Date:   Mon Mar 16 12:18:59 2009 +0000

    fix for MS ODBC

diff --git a/ChangeLog b/ChangeLog
index faac559..55ac602 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Mar 16 13:18:31 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/common.c: disable buffering
+	* src/odbc/unittests/const_params.c: fix for MS ODBC
+
 Mon Mar 16 08:49:25 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/net.c: roll back to avoid possible core in OpenSSL code
 
@@ -1401,4 +1405,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2749 2009/03/16 07:49:57 freddy77 Exp $
+$Id: ChangeLog,v 1.2750 2009/03/16 12:18:59 freddy77 Exp $
diff --git a/src/odbc/unittests/common.c b/src/odbc/unittests/common.c
index fd4c3c0..3c1c049 100644
--- a/src/odbc/unittests/common.c
+++ b/src/odbc/unittests/common.c
@@ -12,7 +12,7 @@
 #define TDS_SDIR_SEPARATOR "\\"
 #endif
 
-static char software_version[] = "$Id: common.c,v 1.53 2008/12/03 12:55:52 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.54 2009/03/16 12:19:03 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 HENV Environment;
@@ -71,6 +71,9 @@ read_login_info(void)
 	int len;
 #endif
 
+	setbuf(stdout, NULL);
+	setbuf(stderr, NULL);
+
 	s1 = getenv("TDSPWDFILE");
 	if (s1 && s1[0])
 		in = fopen(s1, "r");
diff --git a/src/odbc/unittests/const_params.c b/src/odbc/unittests/const_params.c
index 7b9b225..dd956c2 100644
--- a/src/odbc/unittests/const_params.c
+++ b/src/odbc/unittests/const_params.c
@@ -2,7 +2,7 @@
 
 /* Test for {?=call store(?,123,'foo')} syntax and run */
 
-static char software_version[] = "$Id: const_params.c,v 1.16 2008/11/04 14:46:17 freddy77 Exp $";
+static char software_version[] = "$Id: const_params.c,v 1.17 2009/03/16 12:19:03 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -39,32 +39,36 @@ main(int argc, char *argv[])
 
 	if (out1 != 7654321) {
 		fprintf(stderr, "Invalid output %d (0x%x)\n", (int) out1, (int) out1);
-		exit(1);
+		return 1;
 	}
 
 	/* just to reset some possible buffers */
 	Command("DECLARE @i INT");
 
-	CHKBindParameter(1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind,  "S");
-	CHKBindParameter(2, SQL_PARAM_INPUT,  SQL_C_SLONG, SQL_INTEGER, 0, 0, &input,  0, &ind2, "S");
-	CHKBindParameter(3, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1,   0, &ind3, "S");
+	/* MS ODBC don't support empty parameters altough documented so avoid this test */
+	if (driver_is_freetds()) {
 
-	/* TODO use {ts ...} for date */
-	CHKPrepare((SQLCHAR *) "{?=call const_param(?, , '2004-10-15 12:09:08', 'foo', ?)}", SQL_NTS, "S");
+		CHKBindParameter(1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind,  "S");
+		CHKBindParameter(2, SQL_PARAM_INPUT,  SQL_C_SLONG, SQL_INTEGER, 0, 0, &input,  0, &ind2, "S");
+		CHKBindParameter(3, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1,   0, &ind3, "S");
 
-	input = 13579;
-	ind2 = sizeof(input);
-	out1 = output = 0xdeadbeef;
-	CHKExecute("S");
+		/* TODO use {ts ...} for date */
+		CHKPrepare((SQLCHAR *) "{?=call const_param(?, , '2004-10-15 12:09:08', 'foo', ?)}", SQL_NTS, "S");
 
-	if (out1 != 7654321) {
-		fprintf(stderr, "Invalid output %d (0x%x)\n", (int) out1, (int) out1);
-		exit(1);
-	}
+		input = 13579;
+		ind2 = sizeof(input);
+		out1 = output = 0xdeadbeef;
+		CHKExecute("S");
+
+		if (out1 != 7654321) {
+			fprintf(stderr, "Invalid output %d (0x%x)\n", (int) out1, (int) out1);
+			return 1;
+		}
 
-	if (output != 24680) {
-		fprintf(stderr, "Invalid result %d (0x%x) expected 24680\n", (int) output, (int) output);
-		exit(1);
+		if (output != 24680) {
+			fprintf(stderr, "Invalid result %d (0x%x) expected 24680\n", (int) output, (int) output);
+			return 1;
+		}
 	}
 
 	Command("IF OBJECT_ID('const_param') IS NOT NULL DROP PROC const_param");

